﻿using System;
using System.ComponentModel;

namespace ChartApp
{


  public class DataPoint : INotifyPropertyChanged
  {
    private DateTime timeStampField;
    public event PropertyChangedEventHandler PropertyChanged;
    private string deviceNameField;
    private double valueField;
    public DateTime TimeStamp
    {
      get => timeStampField;
      set
      {
        if (timeStampField.Equals(value) != true)
        {
          timeStampField = value;
          RaisePropertyChanged("TimeStamp");
        }
      }
    }

    public string DeviceName
    {
      get => deviceNameField;
      set
      {
        if (ReferenceEquals(deviceNameField, value)) return;
        deviceNameField = value;
        RaisePropertyChanged("DeviceName");
      }
    }

    public double Value
    {
      get => valueField;
      set
      {
        if (valueField.Equals(value) != true)
        {
          valueField = value;
          RaisePropertyChanged("Value");
        }
      }
    }

    protected void RaisePropertyChanged(string propertyName)
    {
      var propertyChanged = PropertyChanged;
      propertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
    }
  }
}
