﻿using System.Collections.Generic;

namespace ChartApp.Utils
{
  using Infragistics.Controls.Charts;

  public class XAxisTickmarkValues : TickmarkValues
  {
    protected double first;
    protected double last;

    /// <summary>
    /// Initializes tick mark values prior to rendering axis labels, strip lines, and gridlines
    /// </summary>
    /// <param name="initializationParameters"></param>
    public override void Initialize(TickmarkValuesInitializationParameters initializationParameters)
    {
      base.Initialize(initializationParameters);
      // Initialize is overridden in order to store the minimum and maximum values, 
      // which will be later used in the MajorValues() and MinorValues() methods.
      first = initializationParameters.VisibleMinimum;
      last = initializationParameters.VisibleMaximum;
    }

    public override IEnumerable<double> MajorValues()
    {
      var ticks = new List<double>();
      for (var point = first; point < last; point += 12E+7)
      {
        ticks.Add(point);
      }

      return ticks;
    }

    public override IEnumerable<double> MinorValues()
    {
      return new double[] {/* no minor tick marks */};
    }
  }
}
